coins = {}
allCoins = {}
app = {}
    
  --------------Clears the entire table of coins. You call it when the scene loads (ttInitScript).----------------------------
    coins.reset = function ()
      for i = 1, 12 do
        local emptyCoin = {}
        emptyCoin.visibility = 1
        emptyCoin.collected = 0
        print ("We are adding an emptyCoin in possition.."..i)
        allCoins[i] = emptyCoin
      end
    end
--------------------------------------------------------------

--------------Adds a table entry for that coinNumber in that table with a value 0. You call it when you complete a tool-------

    coins.setVisible = function (coinNumber)
      allCoins[coinNumber].visibility = 0
      print ("We are setting visibility to coin number "..coinNumber.." to 0")
    end 

------------------------------------------------------------------------------


--Returns true if that coin exists in the table and also the value is 1. You call it in order to know if to show that specific coin animation.-------
    coins.isVisible = function (coinNumber)
      print ("Item number "..coinNumber.." has visilibity: "..allCoins[coinNumber].visibility)
      return allCoins[coinNumber].visibility
    end

----------------------------------------------------------------------------------------------

--------------Sets that coin as collected. Set it to 1 in the table. You call is after you do an animation for a coin.-------
    coins.setCollected = function (coinNumber)
      allCoins[coinNumber].collected = 1
      print ("We are setting collected value to coin number "..coinNumber.." to 1")
    end 

------------------------------------------------------------------------------------

--------------Returns true if that coin value is 1.-------
    coins.isCollected = function (coinNumber)
      print ("Item number "..coinNumber.." has collected value: "..allCoins[coinNumber].collected)
      return allCoins[coinNumber].collected
    end

---------------------------------------------------------


--------------gets the number of coins with value 1 divided by 12 (times 100). You call is when you want to update the value of the progress bar.-------
    coins.getCollectedPercentage = function ()
     local collectedCount = 0
      for i, v in ipairs (allCoins) do
        if coins.isCollected(i) == 1 then collectedCount = collectedCount + 1 
        end
      end

      local coinsPercentage = (collectedCount / 12 ) * 100
      print ("Of the total coins percentage collected is: "..coinsPercentage)
      return coinsPercentage
    end

-----------------------------------------------------------------------------


--------------Scripts for testing----------------------------

    coins.reset ()

    coins.setVisible (2)
    coins.isVisible (2)
    coins.setCollected (2)
    coins.setCollected (3)
    coins.setCollected (4)
    coins.setCollected (5)
    coins.isCollected (2)
    coins.getCollectedPercentage ()

-----------------------------------------------------------------------------



------------------------------------
--coins and purchases 
------------------------------------

app.getConfigData = function(tbl,row,column)
    idx = ConfigTables.Index:new(tbl,row,column)
    r,val = config:get(idx,v)
    return r,val
end

app.addCoins = function(coins)
    scores:getScore("coins"):increaseValue(coins)
end

app.getCoins = function()
    return scores:getScore("coins"):getValue()
end

app.getItemPrice = function(item)
    r,itemPrice = app.getConfigData("rewards",item,"price")
    if (not r) then
        error("app.getItemPrice - item "..item.." doesn't have price")
    end
    return tonumber(itemPrice)
end

app.purchase = function(item)
    print("app.purchase - trying to purchase "..item)
    r,rewardPrice = app.getConfigData("rewards",item,"price")
    consumableExists,consumableValue = app.getConfigData("rewards",item,"consumable")

    if (app.canPurchase(item) and consumableValue == "false") then
        scores:getScore(item):increaseValue(1)
        scores:getScore("coins"):increaseValue(-rewardPrice)
        print("app.purchase - "..item.." was purchased")
    end
    
    if (app.canPurchase(item) and consumableValue == "true") then
        scores:getScore("coins"):increaseValue(-rewardPrice)
        print("app.purchase - "..item.." was purchased")
    end
end

app.canPurchase = function(item)
    r,rewardPrice = app.getConfigData("rewards",item,"price")
    consumableExists,consumableValue = app.getConfigData("rewards",item,"consumable")

    print("app.canPurchase - checking if "..item.." can be purchased..")
    if (app.isPurchased(item)) then 
        return false
    end
    coinsForPurchase = scores:getScore("coins"):getValue()
    return (tonumber(rewardPrice) <= coinsForPurchase)
end

app.isPurchased = function(item)
    print("app.isPurchased - checking if "..item.." is purchased..")
    if (app.getItemPrice(item) == 0) then
        return true
    end

    consumableExists,consumableValue = app.getConfigData("rewards",item,"consumable")
    if (consumableValue  == "true") then
        return false
    end
    
    if (not scores:exists(item)) then
        error("app.isPurchased - item "..item.." doesn't exist in the scoring board")
    end

    itemScore = scores:getScore(item):getValue()
    return (itemScore > 0)
end

app.resetScore = function(item)
    scores:getScore(item):reset()
end

app.canPurchaseAnything = function()
    print("app.canPurchaseAnything - checking if any item can be purchased..")
    r,rowId = config:getFirstRow("rewards",v)
    while (r == true) do
        if (app.canPurchase(rowId)) then 
            return true
        end
        r, rowId = config:getNextRow("rewards", rowId, v)
    end
    return false
end

app.getItemPurchaseStatus = function(item)
    print("app.getItemPurchaseStatus - trying to get purchase status of "..item)
    if (app.isPurchased(item)) then
        return 0
    end

    itemPrice = app.getItemPrice(item)
    if (itemPrice > app.getCoins()) then
        return 1
    end
    
    itemPrice = app.getItemPrice(item)
    if (itemPrice <= app.getCoins()) then
        return 2
    end
end

app.resetAllGifts = function()
    app.resetScore("gift1")
    app.resetScore("gift2")
    app.resetScore("gift3")
    app.resetScore("gift4")
    app.resetScore("gift5")
    app.resetScore("gift6")
    app.resetScore("gift7")
    app.resetScore("gift8")
    app.resetScore("gift9")
end


app.getVideoClickCount = function()
    print("app.getVideoClickCount - trying to get videoclickCount ")
    app.incrementVideoClickCount ()
    local valueForEvent = scores:getScore("videosTried"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.getVideoDoneCount = function()
    print("app.getVideoDoneCount - trying to get videodoneCount ")
    app.incrementVideoWatchedCount ()
    local valueForEvent = scores:getScore("videosDone"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.incrementVideoClickCount = function()
    print("app.incrementVideoClickCount - trying to increase videoclickCount ")
    scores:getScore("videosTried"):increaseValue(1)
end


app.incrementVideoWatchedCount = function()
    print("app.incrementVideoWatchedCount - trying to increase videodoneCount ")
    scores:getScore("videosDone"):increaseValue(1)
end


srvc = {}

srvc.isAndroid = function()
    print("srvc.isAndroid "..tostring(isAndroid).."")
    return (isAndroid == 1)
end

------------------------------
--balloons
------------------------------
--state 0 = free wire
--state 1 = occupied wire
app.initListOfWires = function(numOfBalloonsInList)
    constNumOfWires = numOfBalloonsInList
    print("entered app.initListOfWires")
    print("numOfBalloonsInList:"..numOfBalloonsInList)
    wiresList={}
    for j=1,numOfBalloonsInList do
        wiresList[j] = 0
        print("wiresList[j]:"..wiresList[j])
    end
end

--state -1 = not inflated
--state >0 = represents the wire number on which the inflated is hanged on
app.initListOfBalloons = function(numOfBalloonsInList)
    print("entered app.initListOfBalloons")
    print("numOfBalloonsInList:"..numOfBalloonsInList)
    balloonsList={}
   for i=1,numOfBalloonsInList do
        balloonsList[i] = -1
        print("balloonsList[i]:"..balloonsList[i])
    end
end

--wires get/set
app.setWireState = function(WireNum,state)
    print("entered app.setWireState")
    print("WireNum:"..WireNum)
    print("state:"..state)
    wiresList[WireNum]=state
end

app.getWireState = function(WireNum)
    print("entered app.getWireState")
    print("WireNum:"..WireNum)
    print("wiresList[WireNum]:"..wiresList[WireNum])
    return (wiresList[WireNum])
end

--balloons get/set
app.setBalloonState = function(varNum,state)
    print("entered app.setBalloonState")
    print("varNum:"..varNum)
    print("state:"..state)
    balloonsList[varNum]=state
end

app.getBalloonState = function(varNum)
    print("entered app.getBalloonState")
    print("varNum:"..varNum)
    print("balloonsList[varNum]:"..balloonsList[varNum])
    return (balloonsList[varNum])
end



knittingItems = {}

app.setItemColor = function (itemname, itemcolorR, itemcolorG, itemcolorB)
  local tempItem = {}
  tempItem.colorR = itemcolorR
  tempItem.colorG = itemcolorG
  tempItem.colorB = itemcolorB
  knittingItems[itemname] = tempItem
end

app.getItemColor = function (itemname)
  if (knittingItems[itemname] == null) then print ("Item does not exist") return 0
else print (knittingItems[itemname].colorR.." "..knittingItems[itemname].colorG.." "..knittingItems[itemname].colorB) 
  return knittingItems[itemname].colorR, knittingItems[itemname].colorG, knittingItems[itemname].colorB
end
end

app.getItemColorR = function (itemname)
  if (knittingItems[itemname] == null) then print ("Item does not exist") return 0
else print (knittingItems[itemname].colorR) 
  return knittingItems[itemname].colorR
end
end

app.getItemColorG = function (itemname)
  if (knittingItems[itemname] == null) then print ("Item does not exist") return 0
else print (knittingItems[itemname].colorG) 
  return knittingItems[itemname].colorG
end
end

app.getItemColorB = function (itemname)
  if (knittingItems[itemname] == null) then print ("Item does not exist") return 0
else print (knittingItems[itemname].colorB) 
  return knittingItems[itemname].colorB
end
end

app.getScoreValue = function(scoreName)
    return scores:getScore(scoreName):getValue()
end

app.setScoreValue = function(scoreName, value)
    scores:getScore(scoreName):setValue(value)
end
app.calculateCoinsGainedInScene = function(sceneName, amount)
    if (amount > 29) then
        coinsEarned = 300
    
        scores:getScore(sceneName.."_coinsGained"):increaseValue(coinsEarned)
    
        vars:setVar("coinsEarned", coinsEarned)
        vars:setVar("lastScenePlayed", sceneName)
        vars:setVar("showEndLevelPopup", 1)
    end
end

app.shouldShowCoinBag = function(sceneName,bagSize)
    scoreVal = app.getScoreValue(sceneName.."_coinsGained")
    r,minCoins = app.getConfigData("coinsBags",bagSize,"min")
    r,maxCoins = app.getConfigData("coinsBags",bagSize,"max")
    minCoins = tonumber(minCoins)
    maxCoins = tonumber(maxCoins)
    return (scoreVal >= minCoins and scoreVal <= maxCoins)
end

app.addCoinsFromScene = function(sceneName)
    sceneCoins = app.getScoreValue(sceneName.."_coinsGained")
    app.addCoins(sceneCoins)
    app.setScoreValue(sceneName.."_coinsGained",0)
end


app.resetAllScores = function()
    print("app.resetScores - reseting all scores...")
    scores:reset()
end

-- gift shop toys purchased 
app.initListOfGifts = function(numOfGifts)
    giftsList={}
    for j=1,numOfGifts do
        giftsList[j] = 0
        print("giftsList[j]:"..giftsList[j])
    end
end

app.setGiftState = function(giftNum,state)
    giftsList[giftNum]=state
end

app.getGiftState = function(giftNum)
    return (giftsList[giftNum])
end